off_t current;
struct stat sbuf;
- /* (A good comment is missing here) */
- current = lseek(fd, 0, SEEK_CUR);
/* /proc files report zero st_size, don't lseek them. */
- if (fstat(fd, &sbuf) == 0 && sbuf.st_size)
+ if (fstat(fd, &sbuf) == 0 && sbuf.st_size) {
+ current = lseek(fd, 0, SEEK_CUR);
if (sbuf.st_size < current)
lseek(fd, 0, SEEK_SET);
+ }
r = full_read(fd, buf, count);
if (r < 0) {
#if ENABLE_FEATURE_FANCY_TAIL
/* q: make it impossible for nfiles to be > header_threshhold */
if (opt & 0x8) header_threshhold = UINT_MAX; // -q
+ //if (opt & 0x10) // -s
if (opt & 0x20) header_threshhold = 0; // -v
-#define FOLLOW_RETRY (opt & 0x40)
+# define FOLLOW_RETRY (opt & 0x40)
#else
-#define FOLLOW_RETRY 0
+# define FOLLOW_RETRY 0
#endif
argc -= optind;
argv += optind;
off_t current = lseek(fds[i], 0, SEEK_END);
if (current > 0) {
if (count == 0)
- continue; /* showing zero lines is easy :) */
+ continue; /* showing zero bytes is easy :) */
current -= count;
if (current < 0)
current = 0;
buf = tailbuf;
taillen = 0;
+ /* "We saw 1st line/byte".
+ * Used only by +N code ("start from Nth", 1-based) */
seen = 1;
newlines_seen = 0;
while ((nread = tail_read(fds[i], buf, tailbufsize-taillen)) > 0) {
if (from_top) {
int nwrite = nread;
if (seen < count) {
+ /* We need to skip a few more bytes/lines */
if (COUNT_BYTES) {
nwrite -= (count - seen);
seen = count;
--- /dev/null
+#!/bin/sh
+
+# Copyright 2009 by Denys Vlasenko <vda.linux@googlemail.com>
+# Licensed under GPL v2, see file LICENSE for details.
+
+. testing.sh
+
+# testing "test name" "command" "expected result" "file input" "stdin"
+# file input will be file called "input"
+# test can create a file "actual" instead of writing to stdout
+
+testing "tail: +N with N > file length" \
+ "tail -c +55 2>&1; echo \$?" \
+ "0\n" \
+ "" "qw"
+
+exit $FAILCOUNT